--psetobj.e
--Defines the SemiSet Object (not a true set)
--A Pset may contain the same entry twice with the Pset_Append function.

global type SemiSet(object s)
  return sequence(s)
end type  

global function New_SemiSet_Object()
  return {}
end function

global function SemiSet_Insert(SemiSet s, object obj)
  if find(obj,s) then
    return s
  end if
  return s & {obj}
end function

global function SemiSet_Append(SemiSet s, object obj)
  return s & {obj}
end function  

global function SemiSet_Remove(SemiSet s, object obj)
  integer loc
  loc = find(obj,s)
  if loc then
    return s[1..loc-1] & s[loc+1..length(s)]
  end if
  return s
end function

global function SemiSet_Remove_All(SemiSet s, object obj)
  while find(obj,s) do
    s = SemiSet_Remove(s, obj)
  end while
  return s
end function    
